/******************************************************************************
**
** Version initiale.
** ----------------
** Ce programme se compose de trois fonctions. La fonction de distributeur
** est charge de lire les caractres en provenance de l'entre standard,
** d'envoyer les chiffres  compteur_chiffres et les lettres  compteur_lettres.
** Une fois la fin de fichier atteinte, les fonctions renvoient leurs
** rsultats  la fonction de distribution qui affiche ensuite les rsultats.
**
******************************************************************************/

#include <assert.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

/*
 * Distribution des caractres et affichage des rsultats.
 */
void distributeur() {
  int car;
  int somme_chiffres = 0;
  char lettre_max = ' ';
  /* Distribution des caractres. */
  do {
    car = getchar() ;

    if (isalpha(car) || (car == EOF)) {
      /* on envoie le caractere a compteur_lettres */

      /* A COMPLETER */
    }

    if (isdigit(car) || (car == EOF)) {
      /* on envoie le caractere a compteur_chiffres */

      /* A COMPLETER */
    }
  } while(car != EOF);

  /* On recupere les rsultats */

  /* A COMPLETER */

  printf("Somme des chiffres: %d\n", somme_chiffres);
  printf("La lettre la plus frequente est : %c\n", lettre_max);
}

/*
 * Fait la somme de tous les chiffres distribus
 */
void compteur_chiffres() {
  int c = 0;
  int somme = 0;

  while(1) {
    /* On reoit un chiffre */

    /* A COMPLETER */

    somme += (c - '0');
  }

  /* On envoie le rsultat */

  /* A COMPLETER */
}

/*
 * Calcule la lettre la plus frquente
 */
void compteur_lettres() {
  int c = 0;
  static int frequence['z' - 'a' + 1] ;

  while(1) {
    /* On reoit une lettre */

    /* A COMPLETER */

    frequence [ tolower ( c ) - 'a' ] ++ ;
  }

  /* On cherche la lettre la plus frquente */
  int i;
  int freq_max = 0;
  int lettre_max = ' ';
  for(i=0; i<'z' - 'a' + 1; i++) {
    if(frequence[i]>freq_max) {
      lettre_max = i+'a';
      freq_max= frequence[i];
    }
  }

  /* On envoie le rsultat */

  /* A COMPLETER */

}

/*
 * Lancement de la fonction de distribution.
 */
int main(int argc, char* argv[]) {
  int ret;
  /* Initialisation */

  /* A COMPLETER */

  /* Cration des processus chargs de traiter les chiffres et les lettres */
  ret = fork();
  assert(ret>=0);
  if(!ret) {
    /* processus fils */
    compteur_chiffres();
    exit(0);
  }

  ret = fork();
  assert(ret>=0);
  if(!ret) {
    /* 2eme processus fils */
    compteur_lettres();
    exit(0);
  }

  /* Lancement du travail. */
  distributeur();


  int status;
  /* attente de la terminaison des 2 fils */
  ret = wait(&status);
  assert(ret>=0);

  ret = wait(&status);
  assert(ret>=0);

  /* Tout s'est bien termin. */
  exit(0);
}
